<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Withdrawal extends CI_Controller {

	public function __construct() 
	{
		parent::__construct();
		
		$this->lang->load('account_general', get_language());
		$this->load->model('member_model');
    }
	
	public function index()
	{
		// $current_day = date('w', time());
		// if($current_day >= 1 && $current_day <= 5) {
			save_current_url(base_url() . 'withdrawal/');
			
			if($this->session->userdata('user_type') && $this->session->userdata('user_type') == MEMBER) {
				if($this->session->userdata('member_allowed_withdraw') AND $this->session->userdata('member_allowed_withdraw') == 1) {
					$this->load->model('member_model');
					$data = $this->member_model->get_member_account_details();
					$data['setting'] = $this->member_model->get_setting_rates();
					$data['currency'] = $this->member_model->get_currency_rate();
					
					$data['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_withdrawal') . ' | ' . $this->lang->line('hf_withdraw_request');
					
					$this->load->view('withdrawal', $data);
				}
				else {
					redirect('', 'refresh');
				}	
			}
			else {
				redirect('', 'refresh');
			}
		// }
		// else {
			// redirect('', 'refresh');
		// }
	}
	
	public function submit()
	{
		// $current_day = date('w', time());
		// if($current_day >= 1 && $current_day <= 5) {
			if($this->session->userdata('user_type') && $this->session->userdata('user_type') == MEMBER) {
				if($this->session->userdata('member_allowed_withdraw') AND $this->session->userdata('member_allowed_withdraw') == 1) {
					if($_POST) {
						$rs = $this->member_model->member_to_withdraw();
						
						echo $rs;
					}
					else {
						echo $this->lang->line('permission_denied');
					}
				}
				else {
					echo $this->lang->line('permission_denied');
				}	
			}
			else {
				echo $this->lang->line('permission_denied');
			}
		// }
		// else {
			// echo $this->lang->line('permission_denied');
		// }
	}
	
	public function listing()
	{
		save_current_url(base_url() . 'withdrawal/listing/');
		
		if($this->session->userdata('user_type') && $this->session->userdata('user_type') == MEMBER) {
			$data['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_withdrawal') . ' | ' . $this->lang->line('hf_withdraw_history');
			
			$this->load->view('withdrawal_listing', $data);
		}
		else {
			redirect('', 'refresh');
		}
	}
	
	public function getlist()
    {
		if($this->session->userdata('user_type') && $this->session->userdata('user_type') == MEMBER) {
			$this->lang->load('account_general', get_language());
		
			/* Array of database columns which should be read and sent back to DataTables. Use a space where
			 * you want to insert a non-database field (for example a counter or static image)
			 */
			$aColumns = array(
				$this->db->dbprefix('member_withdraw') . '.transaction_date',
				$this->db->dbprefix('member_withdraw') . '.credit_amount',
				$this->db->dbprefix('member_withdraw') . '.charges',
				$this->db->dbprefix('member_withdraw') . '.currency_id',
				$this->db->dbprefix('member_withdraw') . '.withdrawal_amount',
				$this->db->dbprefix('member_withdraw') . '.wallet_address',
				$this->db->dbprefix('member_withdraw') . '.status',
				$this->db->dbprefix('member_withdraw') . '.to_bank_name',
				$this->db->dbprefix('member_withdraw') . '.to_bank_account_no',
				$this->db->dbprefix('member_withdraw') . '.to_account_holder_name',
				$this->db->dbprefix('member_withdraw') . '.to_bank_address',
				$this->db->dbprefix('member_withdraw') . '.to_bank_country',
			);
			
			// DB table to use
			$sTable = 'member_withdraw';
			//
			
			$this->db->where($this->db->dbprefix('member_withdraw') . '.from_member_id', $this->session->userdata('member_id'));
			$this->db->where($this->db->dbprefix('member_withdraw') . '.transaction_type', 1);
			
			$iDisplayStart = $this->input->get_post('iDisplayStart', true);
			$iDisplayLength = $this->input->get_post('iDisplayLength', true);
			$iSortCol_0 = $this->input->get_post('iSortCol_0', true);
			$iSortingCols = $this->input->get_post('iSortingCols', true);
			$sSearch = $this->input->get_post('sSearch', true);
			$sEcho = $this->input->get_post('sEcho', true);
		
			// Paging
			if(isset($iDisplayStart) && $iDisplayLength != '-1')
			{
				$this->db->limit($this->db->escape_str($iDisplayLength), $this->db->escape_str($iDisplayStart));
			}
			
			// Ordering
			if(isset($iSortCol_0))
			{
				for($i=0; $i<intval($iSortingCols); $i++)
				{
					$iSortCol = $this->input->get_post('iSortCol_'.$i, true);
					$bSortable = $this->input->get_post('bSortable_'.intval($iSortCol), true);
					$sSortDir = $this->input->get_post('sSortDir_'.$i, true);
		
					if($bSortable == 'true')
					{
						$this->db->order_by($aColumns[intval($this->db->escape_str($iSortCol))], $this->db->escape_str($sSortDir));
					}
				}
			}
			
			/* 
			 * Filtering
			 * NOTE this does not match the built-in DataTables filtering which does it
			 * word by word on any field. It's possible to do here, but concerned about efficiency
			 * on very large tables, and MySQL's regex functionality is very limited
			 */
			if(isset($sSearch) && !empty($sSearch))
			{
				for($i=0; $i<count($aColumns); $i++)
				{
					$bSearchable = $this->input->get_post('bSearchable_'.$i, true);
					
					// Individual column filtering
					if(isset($bSearchable) && $bSearchable == 'true')
					{
						$this->db->or_like($aColumns[$i], $this->db->escape_like_str($sSearch));
					}
				}
			}
			
			// Select Data
			$this->db->select('SQL_CALC_FOUND_ROWS '.str_replace(' , ', ' ', implode(', ', $aColumns)), false);
			$rResult = $this->db->get($sTable);
		
			// Data set length after filtering
			$this->db->select('FOUND_ROWS() AS found_rows');
			$iFilteredTotal = $this->db->get()->row()->found_rows;
		
			// Total data set length
			$iTotal = $this->db->count_all($sTable);
		
			// Output
			$output = array(
				'sEcho' => intval($sEcho),
				'iTotalRecords' => $iTotal,
				'iTotalDisplayRecords' => $iFilteredTotal,
				'aaData' => array()
			);
			
			foreach($rResult->result_array() as $aRow)
			{
				$row = array();
				
				$row[] = date('Y-m-d H:i:s', $aRow['transaction_date']);
				$row[] = number_format($aRow['credit_amount'], 2, '.', ',');
				$row[] = number_format($aRow['charges'], 2, '.', ',');
				
				switch($aRow['currency_id']) {
					case 3: $row[] = $this->lang->line('currency_myr_without_symbol'); break;
					default: $row[] = $this->lang->line('currency_usdt'); break;
				}
				
				$row[] = number_format($aRow['withdrawal_amount'], 2, '.', ',');
				
				if($aRow['currency_id'] == 3) {
					$bank_details = '';
					
					if( ! empty($aRow['to_bank_name'])) {
						$bank_details .= $this->lang->line('registration_bank_name') . ': ' . $aRow['to_bank_name'] . '<br />';
					}
					
					if( ! empty($aRow['to_bank_account_no'])) {
						$bank_details .= $this->lang->line('registration_bank_account_no') . ': ' . $aRow['to_bank_account_no'] . '<br />';
					}
					
					if( ! empty($aRow['to_account_holder_name'])) {
						$bank_details .= $this->lang->line('registration_account_holder_name') . ': ' . $aRow['to_account_holder_name'] . '<br />';
					}
					
					if( ! empty($aRow['to_bank_address'])) {
						$bank_details .= $this->lang->line('registration_bank_address') . ': ' . $aRow['to_bank_address'] . '<br />';
					}
					
					if( ! empty($aRow['to_bank_country'])) {
						$bank_details .= $this->lang->line('registration_bank_country') . ': ' . $this->lang->line(get_country_name($aRow['to_bank_country'])) . '<br />';
					}
					
					$row[] = $bank_details;
				}
				else {
					$row[] = $aRow['wallet_address'];
				}
				
				switch($aRow['status']) {
					case 1: $row[] = '<span class="badge bg-success">' . $this->lang->line('withdrawal_paid') . '</span>'; break;
					case 2: $row[] = '<span class="badge bg-danger">' . $this->lang->line('withdrawal_cancelled') . '</span>'; break;
					default: $row[] = '<span class="badge bg-primary">' . $this->lang->line('withdrawal_pending') . '</span>'; break;
				}
				
				$output['aaData'][] = $row;
			}
		
			echo json_encode($output);
		}	
    }
}

/* End of file withdrawal.php */
/* Location: ./application/controllers/withdrawal.php */